#====================================================================================================
# DIRECTORY: ver6/amsu_v6/
# FILE NAME: go.sh
#
# PURPOSE: Compilation shell script
#
# DESCRIPTION: Script to compile the main program in main.f90 and it's supporting routines.
#              The executable "a.out" is created. pgf90 is the Portland Group Fortran compiler.
#
#
# CODE AUTHOR: Danny Braswell, Earth System Science Center, University of Alabama in Huntsville
#
# CREATION DATE: March, 2015
#
# COPYRIGHT: This software and its documentation are considered to be in the public domain
# and thus are available for unrestricted public use. They are furnished "as is". The authors,
# the United States Government, and its instrumentalities, officiers, employees, and agents
# make no warrant, express or implied, as to the usefulness of the software and documentation
# for any purpose. They assume no responsibility (1) for the use of the software and
# documentation; or (2) to provide technical support to users.
#
# INPUTS:
#
# OUTPUTS:
#
# MODIFICATION HISTORY:
#
#====================================================================================================

pgf90 -Mbounds -c ../shared_routines/median.mod.f90
pgf90 -Mbounds -c ../shared_routines/crossing_time.mod.f90
pgf90 -Mbounds -c calendar.mod.f90
pgf90 -Mbounds -c amsu_module.mod.f90
pgf90 -Mbounds    main.f90 \
                  calendar.mod.o \
                  amsu_module.mod.o \
                  median.mod.o \
                  crossing_time.mod.o \
                  -llapack -lblas
