#====================================================================================================
# DIRECTORY: ver6/merge_v6/
# FILE NAME: go.sh
#
# PURPOSE: Compilation shell script
#
# DESCRIPTION: Script to compile the main program in main.f90 and it's supporting routines.
#              The executable "a.out" is created. pgf90 is the Portland Group Fortran compiler.
#
#
# CODE AUTHOR: Danny Braswell, Earth System Science Center, University of Alabama in Huntsville
#
# CREATION DATE: March, 2015
#
# COPYRIGHT: This software and its documentation are considered to be in the public domain
# and thus are available for unrestricted public use. They are furnished "as is". The authors,
# the United States Government, and its instrumentalities, officiers, employees, and agents
# make no warrant, express or implied, as to the usefulness of the software and documentation
# for any purpose. They assume no responsibility (1) for the use of the software and
# documentation; or (2) to provide technical support to users.
#
# INPUTS:
#
# OUTPUTS:
#
# MODIFICATION HISTORY:
#
#====================================================================================================

pgf90 -Mbounds -r8 -c -Kieee nan.mod.f90
pgf90 -Mbounds -r8 -c linear_algebra.mod.f90
pgf90 -Mbounds -r8 -c smooth.mod.f90
pgf90 -Mbounds -r8 -c calendar.mod.f90
pgf90 -Mbounds -r8 -c trend.mod.f90
pgf90 -Mbounds -r8 -c valid_range.mod.f90
pgf90 -Mbounds -r8 -c interpolate.mod.f90
pgf90 -Mbounds -r8 -c regional_masks.mod.f90
pgf90 -Mbounds -r8 main.f90 \
               nan.mod.f90 \
               smooth.mod.o \
               calendar.mod.o \
               linear_algebra.mod.o \
               trend.mod.o \
               valid_range.mod.o \
               interpolate.mod.o \
               regional_masks.mod.o \
               -llapack -lblas
