#!/usr/bin/perl -w

use strict;
use Time::Local;

{

  my $fname;
  my $fnamep;
  my $date;
  my $date_beg;
  my $date_end;
  my $nrec;
  my $nreck;
  my $nkeep;
  my $nrecp;
  my $format;
  my @fields;

  my $nyr;
  my $nmo;
  my $ndy;
  my $nhr;
  my $nmin;
  my $nsec;

  my $cyr;
  my $cmo;
  my $cdy;
  my $chr;
  my $cmn;
  my $css;

  my $nyr_beg;
  my $nmo_beg;
  my $ndy_beg;
  my $nhr_beg;
  my $nmin_beg;
  my $nsec_beg;

  my $cyr_beg;
  my $cmo_beg;
  my $cdy_beg;
  my $chr_beg;
  my $cmn_beg;
  my $css_beg;

  my $nyr_end;
  my $nmo_end;
  my $ndy_end;
  my $nhr_end;
  my $nmin_end;
  my $nsec_end;

  my $cyr_end;
  my $cmo_end;
  my $cdy_end;
  my $chr_end;
  my $cmn_end;
  my $css_end;

  my $nyr_pd;
  my $nmo_pd;
  my $cyrp;
  my $cmop;
  my $stype;

  my $nfind_notes;
  my @notes;
  my $note_max;
  my $nr;

  my $com_max;
  my @com_hold;
  my $nfind_com;
  my $nskip;
  my $str1;
  my $str2;
  my $region_def_style;
  my $missing_data_style;
  my $force_region_global_comment;

#	exit;
 
  $fname = $ARGV[0];
  $date = $ARGV[1];
  $date_beg = $ARGV[2];
  $date_end = $ARGV[3];
  $nyr_pd = $ARGV[4];
  $nmo_pd = $ARGV[5];
  $region_def_style = $ARGV[6];
  $missing_data_style = $ARGV[7];
  $fnamep = $ARGV[8];

  $force_region_global_comment = 0;
  $force_region_global_comment = 1;

  print "\n";
  print " fname = ", $fname, "\n";
  print " date = ", $date, "\n";
  print " date_beg = ", $date_beg, "\n";
  print " date_end = ", $date_end, "\n";
  print " nyr_pd = ", $nyr_pd, "\n";
  print " nmo_pd = ", $nmo_pd, "\n";
  print " region_def_style = ", $region_def_style, "\n";
  print " missing_data_style = ", $missing_data_style, "\n";
  print " fnamep = ", $fnamep, "\n";
  print " force_region_global_comment = ", $force_region_global_comment, "\n";

# $fname = "global_attributes_amg_mt.txt.5.6"
# $date = "2016-03-02T18:23:35Z";
# $date_beg = "2016-03-02T18:23:35Z";
# $date_end = "2016-03-02T18:23:35Z";
# $nyr_pd = 30;
# $nmo_pd = 3;

###########################################################################
# Current Date

  $nyr = substr ( $date, 0, 4 );
  $nmo = substr ( $date, 5, 2 );
  $ndy = substr ( $date, 8, 2 );
  $nhr = substr ( $date, 11, 2 );
  $nmin = substr ( $date, 14, 2 );
  $nsec = substr ( $date, 17, 2 );

  $cyr = sprintf "%2.2d", $nyr;
  $cmo = sprintf "%2.2d", $nmo;
  $cdy = sprintf "%2.2d", $ndy;
  $chr = sprintf "%2.2d", $nhr;
  $cmn = sprintf "%2.2d", $nmin;
  $css = sprintf "%2.2d", $nsec;

###########################################################################
# Start file Date

  $nyr_beg = substr ( $date_beg, 0, 4 );
  $nmo_beg = substr ( $date_beg, 5, 2 );
  $ndy_beg = substr ( $date_beg, 8, 2 );
  $nhr_beg = substr ( $date_beg, 11, 2 );
  $nmin_beg = substr ( $date_beg, 14, 2 );
  $nsec_beg = substr ( $date_beg, 17, 2 );

  $cyr_beg = sprintf "%2.2d", $nyr_beg;
  $cmo_beg = sprintf "%2.2d", $nmo_beg;
  $cdy_beg = sprintf "%2.2d", $ndy_beg;
  $chr_beg = sprintf "%2.2d", $nhr_beg;
  $cmn_beg = sprintf "%2.2d", $nmin_beg;
  $css_beg = sprintf "%2.2d", $nsec_beg;

###########################################################################
# End file Date

  $nyr_end = substr ( $date_end, 0, 4 );
  $nmo_end = substr ( $date_end, 5, 2 );
  $ndy_end = substr ( $date_end, 8, 2 );
  $nhr_end = substr ( $date_end, 11, 2 );
  $nmin_end = substr ( $date_end, 14, 2 );
  $nsec_end = substr ( $date_end, 17, 2 );

  $cyr_end = sprintf "%2.2d", $nyr_end;
  $cmo_end = sprintf "%2.2d", $nmo_end;
  $cdy_end = sprintf "%2.2d", $ndy_end;
  $chr_end = sprintf "%2.2d", $nhr_end;
  $cmn_end = sprintf "%2.2d", $nmin_end;
  $css_end = sprintf "%2.2d", $nsec_end;

###########################################################################

  $nfind_notes = 0;

  if ( -e "notes.txt" ) {
    open LOG, "< notes.txt";
    chomp ( @notes = <LOG> );
    close LOG;
    $nfind_notes = 1;
    unlink "notes.txt";
  }

  $nfind_com = 0;

  if ( -e "region_def.txt" ) {
    print "\n";
    print " file region_def.txt EXISTS\n";
    open LOG, "< region_def.txt";
    chomp ( @com_hold = <LOG> );
    close LOG;
    $nfind_com = 1;
    unlink "region_def.txt";
  }

  if ( -e "region_comment.txt" ) { unlink "region_comment.txt"; }
  if ( -e "missing_comment.txt" ) { unlink "missing_comment.txt"; }

  $format = "%s%s%s%s";

  open LOG, "< $fname";
  open LOG2, "> new.txt";

  while ( defined ( $nrec = <LOG>) ) {

    chomp $nrec;
    if ( $nrec eq "" or $nrec eq " " ) { next; }

    $stype = 1;
    $nskip = 0;

    if ( $nrec =~ m/id =/ ) {
#     id = "uah_msu_tlt_monamg_v05r04_197812_YYYYMM.nc";
#     Templates have wrong version
#     $nrec =~ s/v05r04/v05r06/;
#     $nrec =~ s/ZZZZ/$cyr_beg/;
#     $nrec =~ s/NN/$cmo_beg/;
#     $nrec =~ s/YYYY/$cyr_end/;
#     $nrec =~ s/MM/$cmo_end/;
      $nrec = "id = " . $fnamep;
    } elsif ( $nrec =~ m/date_created/ ) {
      $nrec =~ s/YYYY/$nyr/;
      $nrec =~ s/MM/$cmo/;
      $nrec =~ s/DD/$cdy/;
      $nrec =~ s/HH/$chr/;
      $nrec =~ s/MM/$cmn/;
      $nrec =~ s/SS/$css/;
    } elsif ( $nrec =~ m/date_modified/ ) {
      $nrec =~ s/YYYY/$nyr/;
      $nrec =~ s/MM/$cmo/;
      $nrec =~ s/DD/$cdy/;
      $nrec =~ s/HH/$chr/;
      $nrec =~ s/MM/$cmn/;
      $nrec =~ s/SS/$css/;
    } elsif ( $nrec =~ m/time_coverage_start/ ) { # time_coverage_start = "YYYY-MM-DDTHH:MM:SSZ";
      $nrec =~ s/YYYY/$nyr_beg/;
      $nrec =~ s/MM/$cmo_beg/;
      $nrec =~ s/DD/$cdy_beg/;
      $nrec =~ s/HH/$chr_beg/;
      $nrec =~ s/MM/$cmn_beg/;
      $nrec =~ s/SS/$css_beg/;
    } elsif ( $nrec =~ m/time_coverage_end/ ) { # time_coverage_end = "YYYY-MM-DDTHH:MM:SSZ";
      $nrec =~ s/YYYY/$nyr_end/;
      $nrec =~ s/MM/$cmo_end/;
      $nrec =~ s/DD/$cdy_end/;
      $nrec =~ s/HH/$chr_end/;
      $nrec =~ s/MM/$cmn_end/;
      $nrec =~ s/SS/$css_end/;
    } elsif ( $nrec =~ m/time_coverage_duration/ ) { # time_coverage_duration = "PYYYMMM";
      $cyrp = sprintf "%3.2d", $nyr_pd;
      $cmop = sprintf "%2.2d", $nmo_pd;
      $nrecp = "P" . $cyrp . "Y" . $cmop . "M";
      $nrecp =~ s/\s+//g;
      $nrec =~ s/PYYYMMM/$nrecp/;

#   } elsif ( $nrec =~ m/metadata_link/ ) {
#     $nrec = 'metadata_link == "https://data.noaa.gov/dataset?q=%22C00961%22"';
#     $stype = 0;

    } elsif ( $nrec =~ m/history/ ) {

      $note_max = $#notes;

#     :history = "netCDF file converted from the ASCII file";

      if ( $note_max >= 0 ) {

        $nrec =~ s/^\s+//g;		# Remove whitespace at beginning of line
        $nrec =~ s/\s+$//g;		# Remove whitespace at end of line
        $nrec =~ s/\;$//;
        $nrec =~ s/\s+$//g;		# Remove whitespace at end of line
        $nrec =~ s/\"$//;
        $nrec =~ s/\s+$//g;		# Remove whitespace at end of line

        for ( $nr = 0; $nr <= $note_max; $nr++ ) {
          $nrecp = $notes[$nr];
          $nrecp =~ s/NOTE//;
          $nrecp =~ s/\://;
          $nrecp =~ s/^\s+//g;		# Remove whitespace at beginning of line
          $nrecp =~ s/\s+$//g;		# Remove whitespace at end of line
          $nrec = $nrec . ", " . $nrecp
        }

      }

    } elsif ( $nrec =~ m/comment/ ) {

      $com_max = $#com_hold;

      print "\n";
      print " comment section\n";
      print " com_max = ", $com_max, "\n";
      print " region_def_style = ", $region_def_style, "\n";
      print " missing_data_style = ", $missing_data_style, "\n";

      if ( $com_max >= 0 ) {

        $nrec = "";
        $nrec = 'comment = "';

#       GL 85S-85N, NH 0-85N, SH 85S-0, TRPCS 20S-20N
#       NoExt 20N-85N, SoExt 85S-20S, NoPol 60N-85N, SoPol 85S-60S

        for ( $nr = 0; $nr <= $com_max; $nr++ ) {
          $nrecp = $com_hold[$nr];
          $nrecp =~ s/^\s+//g;		# Remove whitespace at beginning of line
          $nrecp =~ s/\s+$//g;		# Remove whitespace at end of line
          $nrecp =~ s/GL/GLOBAL/;
          $nrecp =~ s/NH/NORTHERN_HEMISPHERE/;
          $nrecp =~ s/SH/SOUTHERN_HEMISPHERE/;
          $nrecp =~ s/TRPCS/TROPICS/;
          $nrecp =~ s/NoExt/NORTHERN_EXTRATROPICS/;
          $nrecp =~ s/SoExt/SOUTHERN_EXTRATROPICS/;
          $nrecp =~ s/NoPol/NORTH_POLAR/;
          $nrecp =~ s/SoPol/SOUTH_POLAR/;
          if ( $nr != $com_max ) {
            $nrec = $nrec . $nrecp . ", ";
          } else {
            $nrec = $nrec . $nrecp;
          }
        }
 
        if ( $region_def_style eq "GLOBAL" ) {

          $nrec = $nrec . ", ";

        } elsif ( $region_def_style eq "VAR" ) {

          $nreck = $nrec;

          $nrec =~ s/\s+$//g;		# Remove whitespace at end of line
          $nrec =~ s/\,$//;
          $nrec = $nrec . '";';

          ( $str1, $str2 ) = split_rec ( $stype, $nrec );

          @fields = ();
          $fields[0] = $str1;
          $fields[1] = $str2;

          open LOG3, "> region_comment.txt";
          printf LOG3 $format, $fields[0], "#", $fields[1], "\n";
          close LOG3;

          if ( $force_region_global_comment == 0 ) {
            $nrec = "";
            $nrec = 'comment = "';
          } elsif ( $force_region_global_comment == 1 ) {
            $nrec = $nreck;
            $nrec = $nrec . ", ";
          }

          print "\n";
          print " file region_comment.txt WRITTEN\n";

        }

#       global_attributes_ncdc_ls.txt.5.6
#       global_attributes_ncdc_lt.txt.5.6
#       global_attributes_ncdc_mt.txt.5.6

        if ( $fname =~ m/global_attributes_ncdc_ls.txt.5.6/ ) {
 
          if ( $missing_data_style eq "GLOBAL" ) {

            $nrec .= 'Because of an unresolved issue with the original orbit files, values from Jan 1, 2005 onwards are often unreasonable for regions not comprised of all longitudes and have been set to FillValue.  This is true for both regional anomaly and regional trends variables.';

          } elsif ( $missing_data_style eq "VAR" ) {

            $nkeep = $nrec;
            $nrec = "";
            $nrec = 'comment = "';

            $nrec .= 'Because of an unresolved issue with the original orbit files, values from Jan 1, 2005 onwards are often unreasonable for regions not comprised of all longitudes and have been set to FillValue.  This is true for both regional anomaly and regional trends variables.';

            $nrec =~ s/\s+$//g;		# Remove whitespace at end of line
            $nrec =~ s/\,$//;
            $nrec = $nrec . '";';

            ( $str1, $str2 ) = split_rec ( $stype, $nrec );

            @fields = ();
            $fields[0] = $str1;
            $fields[1] = $str2;

            open LOG3, "> missing_comment.txt";
            printf LOG3 $format, $fields[0], "#", $fields[1], "\n";
            close LOG3;

            $nrec = $nkeep;

          }

        }

        if ( $nrec =~ m/^comment = "$/ ) {
          $nskip = 1;
        }

        if ( $nskip == 0 ) {
          $nrec =~ s/\s+$//g;		# Remove whitespace at end of line
          $nrec =~ s/\,$//;
          $nrec = $nrec . '";'
        }

      } elsif ( $com_max < 0 ) { # No regional definition data available

        $nskip = 1;

        if ( $missing_data_style eq "GLOBAL" && $fname =~ m/global_attributes_amg_ls.txt.5.6/ ) {
          $nrec = "";
          $nrec = 'comment = "';
          $nrec .= 'Because of an unresolved issue with the original orbit files, values from Jan 1, 2005 onwards are often unreasonable and have been set to FillValue.';
          $nrec = $nrec . '";';
          $nskip = 0;
        }

        if ( $missing_data_style eq "VAR" && $fname =~ m/global_attributes_amg_ls.txt.5.6/ ) {

          $nrec = "";
          $nrec = 'comment = "';

          $nrec .= 'Because of an unresolved issue with the original orbit files, values from Jan 1, 2005 onwards are often unreasonable and have been set to FillValue.';

          $nrec =~ s/\s+$//g;		# Remove whitespace at end of line
          $nrec =~ s/\,$//;
          $nrec = $nrec . '";';

          ( $str1, $str2 ) = split_rec ( $stype, $nrec );

          @fields = ();
          $fields[0] = $str1;
          $fields[1] = $str2;

          open LOG3, "> missing_comment.txt";
          printf LOG3 $format, $fields[0], "#", $fields[1], "\n";
          close LOG3;
          $nskip = 1;

        }

      }

    }

    if ( $nskip == 0 ) {
      ( $str1, $str2 ) = split_rec ( $stype, $nrec );
      @fields = ();
      $fields[0] = $str1;
      $fields[1] = $str2;
      printf LOG2 $format, $fields[0], "#", $fields[1], "\n";
    }

  }

  close LOG;
  close LOG2;

}

#
######################################################################
#

sub split_rec {

  my ( $stype, $nrec ) = @_;

  my @fields;

  if ( $stype == 1 ) {
    $nrec =~ s/^\s+//g;		# Remove whitespace at beginning of line
    $nrec =~ s/\s+$//g;		# Remove whitespace at end of line
    $nrec =~ s/^\://;
    $nrec =~ s/\;$//;
    @fields = split/\=/, $nrec;
    $fields[0] =~ s/^\s+//g;		# Remove whitespace at beginning of line
    $fields[0] =~ s/\s+$//g;		# Remove whitespace at end of line
    $fields[1] =~ s/^\s+//g;		# Remove whitespace at beginning of line
    $fields[1] =~ s/\s+$//g;		# Remove whitespace at end of line
    $fields[1] =~ s/^\"//;
    $fields[1] =~ s/\"$//;
    $fields[1] =~ s/^\s+//g;		# Remove whitespace at beginning of line
    $fields[1] =~ s/\s+$//g;		# Remove whitespace at end of line
  } elsif ( $stype == 0 ) {
    $nrec =~ s/^\s+//g;		# Remove whitespace at beginning of line
    $nrec =~ s/\s+$//g;		# Remove whitespace at end of line
    $nrec =~ s/^\://;
    $nrec =~ s/\;$//;
    @fields = split/\=\=/, $nrec;
    $fields[0] =~ s/^\s+//g;		# Remove whitespace at beginning of line
    $fields[0] =~ s/\s+$//g;		# Remove whitespace at end of line
    $fields[1] =~ s/^\s+//g;		# Remove whitespace at beginning of line
    $fields[1] =~ s/\s+$//g;		# Remove whitespace at end of line
    $fields[1] =~ s/^\"//;
    $fields[1] =~ s/\"$//;
    $fields[1] =~ s/^\s+//g;		# Remove whitespace at beginning of line
    $fields[1] =~ s/\s+$//g;		# Remove whitespace at end of line
  }

  return ( $fields[0], $fields[1] );

}

#
######################################################################
#
