#!/usr/bin/perl -w

use strict;
use Time::Local;

{

  my $nrec;
  my $nrec1;
  my $nrec2;
  my $nrec3;
  my @fields;
  my @fields2;
  my @fields3;
  my $nff;
  my $nf;
  my $region;
  my $lim1;
  my $lim2;
  my $sign1;
  my $sign2;
  my $tab;
  my $format;
  my %region_hash;
  my $npass;
  my $rkey;
  my $dkey;
  my $nsum;
  my $nss;
  my $ns;

#	exit;

# Year Mo Globe  Land Ocean   NH   Land Ocean   SH   Land Ocean Trpcs  Land Ocean NoExt  Land Ocean SoExt  Land Ocean NoPol  Land Ocean SoPol  Land Ocean USA48 USA49  AUST
     
# GL 85S-85N, NH 0-85N, SH 85S-0, TRPCS 20S-20N
# NoExt 20N-85N, SoExt 85S-20S, NoPol 60N-85N, SoPol 85S-60S

  $tab = chr ( 9 );
  $nrec1 = $ARGV[0];
  $nrec2 = $ARGV[1];
  $nrec3 = $ARGV[2];

  for ( $nf = 1; $nf <= 3; $nf++ ) {
    if ( $nf == 1 ) { $nrec = $nrec1; }
    if ( $nf == 2 ) { $nrec = $nrec2; }
    if ( $nf == 3 ) { $nrec = $nrec3; }
    $nrec =~ s/_/ /g;		# Convert underscores to spaces (underscores used to pass string as one field)
    $nrec =~ s/^\s+//g;		# Remove whitespace at beginning of line
    $nrec =~ s/\s+$//g;		# Remove whitespace at end of line
    if ( $nf == 1 ) { $nrec1 = $nrec; }
    if ( $nf == 2 ) { $nrec2 = $nrec; }
    if ( $nf == 3 ) { $nrec3 = $nrec; }
  }

  print "\n";
  print " nrec1 = ", $nrec1, "\n";
  print " nrec2 = ", $nrec2, "\n";
  print " nrec3 = ", $nrec3, "\n";

  if ( -e "region.txt" ) { unlink "region.txt"; }

  $nrec = $nrec1;
  @fields = split /\s+/, $nrec;
  $nff = $#fields;

# Replace short names in file with longer names required in NetCDF files ...

  $nsum = 0;

  for ( $nf = 2; $nf <= $nff; $nf++ ) {
    $nsum++;
    $dkey = sprintf "%2.2d", $nsum;
    if ( $nf == 2 && $fields[$nf] eq 'Globe' ) {
      $fields[$nf] = "global";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "GL";
    } elsif ( $nf == 3 && $fields[$nf] eq 'Land' ) {
      $fields[$nf] = "global_land";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "GL";
    } elsif ( $nf == 4 && $fields[$nf] eq 'Ocean' ) {
      $fields[$nf] = "global_ocean";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "GL";
    } elsif ( $nf == 5 && $fields[$nf] eq 'NH' ) {
      $fields[$nf] = "northern_hemisphere";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "NH";
    } elsif ( $nf == 6 && $fields[$nf] eq 'Land' ) {
      $fields[$nf] = "northern_hemisphere_land";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "NH";
    } elsif ( $nf == 7 && $fields[$nf] eq 'Ocean' ) {
      $fields[$nf] = "northern_hemisphere_ocean";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "NH";
    } elsif ( $nf == 8 && $fields[$nf] eq 'SH' ) {
      $fields[$nf] = "southern_hemisphere";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "SH";
    } elsif ( $nf == 9 && $fields[$nf] eq 'Land' ) {
      $fields[$nf] = "southern_hemisphere_land";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "SH";
    } elsif ( $nf == 10 && $fields[$nf] eq 'Ocean' ) {
      $fields[$nf] = "southern_hemisphere_ocean";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "SH";
    } elsif ( $nf == 11 && $fields[$nf] eq 'Trpcs' ) {
      $fields[$nf] = "tropics";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "TRPCS";
    } elsif ( $nf == 12 && $fields[$nf] eq 'Land' ) {
      $fields[$nf] = "tropics_land";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "TRPCS";
    } elsif ( $nf == 13 && $fields[$nf] eq 'Ocean' ) {
      $fields[$nf] = "tropics_ocean";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "TRPCS";
    } elsif ( $nf == 14 && $fields[$nf] eq 'NoExt' ) {
      $fields[$nf] = "northern_extratropics";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "NoExt";
    } elsif ( $nf == 15 && $fields[$nf] eq 'Land' ) {
      $fields[$nf] = "northern_extratropics_land";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "NoExt";
    } elsif ( $nf == 16 && $fields[$nf] eq 'Ocean' ) {
      $fields[$nf] = "northern_extratropics_ocean";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "NoExt";
    } elsif ( $nf == 17 && $fields[$nf] eq 'SoExt' ) {
      $fields[$nf] = "southern_extratropics";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "SoExt";
    } elsif ( $nf == 18 && $fields[$nf] eq 'Land' ) {
      $fields[$nf] = "southern_extratropics_land";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "SoExt";
    } elsif ( $nf == 19 && $fields[$nf] eq 'Ocean' ) {
      $fields[$nf] = "southern_extratropics_ocean";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "SoExt";
    } elsif ( $nf == 20 && $fields[$nf] eq 'NoPol' ) {
      $fields[$nf] = "north_polar";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "NoPol";
    } elsif ( $nf == 21 && $fields[$nf] eq 'Land' ) {
      $fields[$nf] = "north_polar_land";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "NoPol";
    } elsif ( $nf == 22 && $fields[$nf] eq 'Ocean' ) {
      $fields[$nf] = "north_polar_ocean";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "NoPol";
    } elsif ( $nf == 23 && $fields[$nf] eq 'SoPol' ) {
      $fields[$nf] = "south_polar";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "SoPol";
    } elsif ( $nf == 24 && $fields[$nf] eq 'Land' ) {
      $fields[$nf] = "south_polar_land";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "SoPol";
    } elsif ( $nf == 25 && $fields[$nf] eq 'Ocean' ) {
      $fields[$nf] = "south_polar_ocean";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "SoPol";
    } elsif ( $nf == 26 && $fields[$nf] eq 'USA48' ) {
      $fields[$nf] = "contiguous_united_states_of_america";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "USA48";
    } elsif ( $nf == 27 && $fields[$nf] eq 'USA49' ) {
      $fields[$nf] = "contiguous_united_states_of_america_plus_alaska";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "USA49";
    } elsif ( $nf == 28 && $fields[$nf] eq 'AUST' ) {
      $fields[$nf] = "australia";
      $region_hash{$fields[$nf]}{"name"} = $fields[$nf];
      $region_hash{$fields[$nf]}{"order"} = $dkey;
      $region_hash{$fields[$nf]}{"rindex"} = "AUST";
    } else {
      print "\n";
      print " unexpected region syntax ???\n";
      print " nf = ", $nf, "\n";
      print " fields[nf] = ", $fields[$nf], "\n";
      exit;
    }
    $region_hash{$fields[$nf]}{"LIM1"} = -9999.0;
    $region_hash{$fields[$nf]}{"LIM2"} = -9999.0;
  }

  for ( $npass = 1; $npass <= 2; $npass++ ) {

    @fields = ();

    if ( $npass == 1 ) {
      $nrec = $nrec2;
    } elsif ( $npass == 2 ) {
      $nrec = $nrec3;
    }

    @fields = split /\,/, $nrec;
    $nff = $#fields;

    for ( $nf = 0; $nf <= $nff; $nf++ ) {
      $fields[$nf]=~ s/^\s+//g;		# Remove whitespace at beginning of line
      $fields[$nf] =~ s/\s+$//g;		# Remove whitespace at end of line
      @fields2 = split /\s+/, $fields[$nf];
      $region = $fields2[0];
      $region =~ s/^\s+//g;		# Remove whitespace at beginning of line
      $region =~ s/\s+$//g;		# Remove whitespace at end of line

      print "\n";
      print " nf = ", $nf, "\n";
      print " nrec = ", $nrec, "\n";
      print " fields[nf] = ", $fields[$nf], "\n";
      print " region = ", $region, "\n";
      print " fields2[0] = ", $fields2[0], "\n";
      print " fields2[1] = ", $fields2[1], "\n";

      @fields3 = split /\-/, $fields2[1];

      $nss = $#fields3;
      print "\n";
      for ( $ns = 0; $ns <= $nss; $ns++ ) {
        print " ns, fields3[ns] = ", $ns, "   ", $fields3[$ns], "\n";
      }

      $lim1 = $fields3[0];
      $lim2 = $fields3[1];
      $lim1 =~ s/^\s+//g;		# Remove whitespace at beginning of line
      $lim1 =~ s/\s+$//g;		# Remove whitespace at end of line
      $lim2 =~ s/^\s+//g;		# Remove whitespace at beginning of line
      $lim2 =~ s/\s+$//g;		# Remove whitespace at end of line

      print "\n";
      print " lim1 = ", $lim1, "\n";
      print " lim2 = ", $lim2, "\n";

      if ( $lim1 =~ m/S$/ ) {
        $sign1 = -1.0;
        $lim1 =~ s/S//;
      } elsif ( $lim1 =~ m/N$/ ) {
        $sign1 = +1.0;
        $lim1 =~ s/N//;
      } else {
        $sign1 = +1.0;
      }
      if ( $lim2 =~ m/S$/ ) {
        $sign2 = -1.0;
        $lim2 =~ s/S//;
      } elsif ( $lim2 =~ m/N$/ ) {
        $sign2 = +1.0;
        $lim2 =~ s/N//;
      } else {
        $sign2 = +1.0;
      }
      $lim1 =~ s/^\s+//g;		# Remove whitespace at beginning of line
      $lim1 =~ s/\s+$//g;		# Remove whitespace at end of line
      $lim2 =~ s/^\s+//g;		# Remove whitespace at beginning of line
      $lim2 =~ s/\s+$//g;		# Remove whitespace at end of line
      $lim1 = $sign1 * $lim1;
      $lim2 = $sign2 * $lim2;

      foreach $rkey ( keys %region_hash ) {
        if ( $region_hash{$rkey}{"rindex"} eq $region ) {
          $region_hash{$rkey}{"LIM1"} = $lim1;
          $region_hash{$rkey}{"LIM2"} = $lim2;
        }
      }

    }

  } # NPASS LOOP

  $format = "%s%s%15.5f%s%15.5f%s";

  open LOG, "> region.txt";

  for ( $nf = 1; $nf <= $nsum; $nf++ ) {
    $dkey = sprintf "%2.2d", $nf;
    foreach $rkey ( keys %region_hash ) {
      if ( $region_hash{$rkey}{"order"} eq $dkey ) {
        $lim1 = $region_hash{$rkey}{"LIM1"};
        $lim2 = $region_hash{$rkey}{"LIM2"};
        printf LOG $format, $rkey, $tab, $lim1, $tab, $lim2, "\n";
      last;
      }
    }
  }

  close LOG;

}

#
######################################################################
#
